/***************************************************************************
 *   Copyright (C) 2008 by Davy Preuveneers                                *
 *   davyp@dev.java.net                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

import java.io.*;
import java.util.*;

import javax.comm.*;

public class GPSTest implements SerialPortEventListener {

    private InputStream $inputStream;
    private SerialPort $serialPort;
    private static CommPortIdentifier $portId;
    private boolean $portFound = false;
    private boolean $closePort = false;

    public void open(String defaultPort) {
        Enumeration portList = portList = CommPortIdentifier.getPortIdentifiers();

        while (portList.hasMoreElements()) {
            $portId = (CommPortIdentifier) portList.nextElement();
            if ($portId.getPortType() == CommPortIdentifier.PORT_SERIAL) {
                if ($portId.getName().equals(defaultPort)) {
                    System.out.println("Found port '" + defaultPort + "'.");
                    $portFound = true;
                    break;
                }
            }
        }

        if ($portFound) {
            try {
                $serialPort = (SerialPort)$portId.open("GPSReadApp", 2000);
            } catch (PortInUseException e) {}

            try {
                $inputStream = (InputStream)$serialPort.getInputStream();
            }
            catch (IOException e) {}

            try {
                $serialPort.addEventListener(this);
            }
            catch (TooManyListenersException e) {}

            $serialPort.notifyOnDataAvailable(true);

            try {
                $serialPort.setSerialPortParams(9600, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
            }
            catch (UnsupportedCommOperationException e) {}
            $closePort = false;
        } else {
            System.out.println("Port '" + defaultPort + "' not found.");
            $serialPort = null;
        }
    }

    public boolean isConnected() {
        return ($serialPort != null);
    }

    public void close() {
        $closePort = true;

        try {
            $serialPort.notifyOnDataAvailable(false);
            $serialPort.removeEventListener();
            $inputStream.close();
            $inputStream = null;

            $serialPort.close();
            $serialPort = null;
        }
        catch (Exception e) {}

        System.out.println("\n\nSerial port closed.\n");
    }

    public void serialEvent(SerialPortEvent event) {
        switch (event.getEventType()) {
            case SerialPortEvent.BI:
            case SerialPortEvent.OE:
            case SerialPortEvent.FE:
            case SerialPortEvent.PE:
            case SerialPortEvent.CD:
            case SerialPortEvent.CTS:
            case SerialPortEvent.DSR:
            case SerialPortEvent.RI:
            case SerialPortEvent.OUTPUT_BUFFER_EMPTY:
                break;
            case SerialPortEvent.DATA_AVAILABLE:
                byte[] readBuffer = new byte[2048];
                try {
                    while (($inputStream.available() > 0) && (!$closePort)) {
                        int numBytes = $inputStream.read(readBuffer);
                        String data = new String(readBuffer, 0, numBytes);
                        System.out.print(data);
                    }
                }
                catch (Exception e) {}
                break;
        }
    }

    public static void main(String args[]) {
        GPSTest $gps = new GPSTest();

        $gps.open("COM6:");
        if (!$gps.isConnected()) {
            return;
        }

        try {
            Thread.sleep(20000);
        }
        catch (Exception e) {}

        $gps.close();
    }
}
